 /*
    This file is part of tdepim.

    Copyright (c) 2004 Cornelius Schumacher <schumacher@kde.org>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/
#ifndef KCAL_RESOURCEFEATUREPLAN_H
#define KCAL_RESOURCEFEATUREPLAN_H

#include "prefs.h"

#include "kde-features.h"

#include <libkcal/resourcecached.h>

#include <tdeabc/locknull.h>

#include <tdemacros.h>
#include <tdeconfig.h>

namespace KCal {

/**
  This class represents a featureplan (in KDE XML format)
*/
class TDE_EXPORT ResourceFeaturePlan : public ResourceCached
{
    TQ_OBJECT
  
  public:
    ResourceFeaturePlan( const TDEConfig * );
    virtual ~ResourceFeaturePlan();

    void readConfig( const TDEConfig *config );
    void writeConfig( TDEConfig *config );

    Prefs *prefs();

    bool doLoad();
    bool doSave();

    TDEABC::Lock *lock();

  protected:
    void insertCategories( const Category::List &categories, Todo *parent );

  private:
    Prefs *mPrefs;
    TDEABC::LockNull mLock;
};

}

#endif
